/*	Author: A.Voss@FH-Aachen.de
 * 
 * 	Thema Mehrfachvererbung, inheritance
 */

#include <iostream>
#include <cstdlib>
using namespace std;

#include "../../include/tools.h"

class A 
{
protected:
    int n;
    
public: 
    A(int N) : n(N) { tools_log(); cout << "ctor A(" << n << ")" << endl; }
    ~A()            { tools_log(); cout << "dtor A(" << n << ")" << endl; }
    
    int getn() const { return n; }
};

class B1 : public A
{
public:
    B1(int N) : A(N) { tools_log(); cout << "ctor B1(" << n << ")" << endl; }
    ~B1()            { tools_log(); cout << "dtor B1(" << n << ")" << endl; }
};

class B2 : public A
{
public:
    B2(int N) : A(N) { tools_log(); cout << "ctor B2(" << n << ")" << endl; }
    ~B2()            { tools_log(); cout << "dtor B2(" << n << ")" << endl; }
};

class C : public B1, public B2			/*	public B1 and public B2 ?
 * 
 * 	Mehrfachvererbung: hier erbt C sowohl von B1 als auch von B2; 
 * 	das bedeutet, alle member von B1 und von B2, und hier ebenfalls 
 * 	zweimal die Member von A! Beachte naechstes Beispiel -V2!
 */
{
public:
    C(int N) : B1(N+1),B2(N+2) { tools_log(); cout << "ctor C(" << B1::n << "," << B2::n << ")" << endl; }
    ~C()                       { tools_log(); cout << "dtor C(" << B1::n << "," << B2::n << ")" << endl; }
/*	B1::n ?
 * 
 * 	Um bei mehreren Moeglichkeiten zu unterscheiden, welche geerbte 
 * 	Klasse man ansprechen moechte, wird diese Syntax verwendet.
 * 	B1::n meint den Member n aus B1.
 */
};

int main()
{
    tools_log(); cout << "define objects" << endl;

	// Man beachte die ctor-Aufrufe!
    tools_log(); cout << "c:" << endl;
    C c(0);
    
    tools_log(); 
    cout << "size B1 = " << sizeof(B1) 
         << ", size B2 = " << sizeof(B2) 
         << ", size C = " << sizeof(C) << endl;
    
    tools_log(); cout << "end of main" << endl;
    
    return EXIT_SUCCESS;
}

