/*	Author: A.Voss@FH-Aachen.de
 * 
 * 	Verwendung von virtuellen Funktionen. Motivation.
 */

#include <iostream>
#include <cstdlib>
#include <vector>
using namespace std;

#include "../../include/tools.h"

#pragma GCC diagnostic ignored "-Wdelete-non-virtual-dtor"

// f ist nicht virtual, g ist
class A
{
public:
    void f()               { tools_log(); cout << "A::f" << endl; }
    virtual void g()       { tools_log(); cout << "A::g" << endl; }
};

// g ist (immer noch) virtual, auch wenn es nicht da steht; f nicht.
class B : public A
{
public:
    void f()               { tools_log(); cout << "B::f" << endl; }
    void g()               { tools_log(); cout << "B::g" << endl; }
};

int main()
{
    tools_log(); cout << "example 1" << endl;
    
    A a;
    B b;
    
    // virtual spielt keine Rolle, a ruft Funktionen aus A auf und b aus B
    tools_log(); cout << "  a:" << endl;
    a.f();
    a.g();
    tools_log(); cout << "  b:" << endl;
    b.f();
    b.g();

    cout << endl;
    tools_log(); cout << "example 2" << endl;
    
    A *pa = new A();
    A *pb = new B();
    // virtual ist wichtig, hier gibt es zwei A* und ein A und ein B Objekt

    tools_log(); cout << "  pa:" << endl;
    pa->f();
    pa->g();

    tools_log(); cout << "  pb:" << endl;
    pb->f();
    pb->g();

    delete pa;
    delete pb;

    cout << endl;
    tools_log(); cout << "example 3" << endl;

    A &ra = a;
    A &rb = b;
    // virtual ist wichtig, hier gibt es zwei A& und ein A und ein B Objekt
    
    tools_log(); cout << "  ra:" << endl;
    ra.f();
    ra.g();

    tools_log(); cout << "  rb:" << endl;
    rb.f();
    rb.g();

    return EXIT_SUCCESS;
}

