/*	Author: A.Voss@FH-Aachen.de
 * 
 * 	Verwendung von virtuellen Funktionen. Motivation.
 */

#include <iostream>
#include <cstdlib>
#include <vector>
using namespace std;

#include "../../include/tools.h"

//#pragma GCC diagnostic ignored "-Wdelete-non-virtual-dtor"
/*	Wozu ist dieses Pragma?
 * 
 * 	Siehe letzte Aufgabe.
 */

class A
{
public:
    A()		{ tools_log(); cout << "ctor A" << endl; }
    virtual ~A()    { tools_log(); cout << "dtor A" << endl; }

    virtual void g()	{ tools_log(); cout << "A::g" << endl; }
};

class B : public A
{
public:
    B()		{ tools_log(); cout << "ctor B" << endl; }
    ~B()    { tools_log(); cout << "dtor B" << endl; }

    void g()         	{ tools_log(); cout << "B::g" << endl; }
};

int main()
{
    tools_log(); cout << "example 1" << endl;
    
    A *pa = new A();
    A *pb = new B();

    tools_log(); cout << "  pa:" << endl;
    pa->g();

    tools_log(); cout << "  pb:" << endl;
    pb->g();

    delete pa;
    delete pb;
    
    /* 	Wo liegt hier ein Problem?
     * 
     * 	Der dtor von B wird nicht aufgerufen! Damit das geschieht, muss
     * 	der dtor von A virtual gekennzeichnet werden. Anders 
     * 	ausgedrueckt: Bei der verwendung von virtuellen Funktionen in
     * 	einer Klassenhierarchie ist das quasi Pflicht.
     * 
     * 	Das oben deaktivierte pragma unterbindet den Warnhinweis auf
     * 	einen nicht-virt. dtor.
     */

    return EXIT_SUCCESS;
}

