/*	Author: A.Voss@FH-Aachen.de
 * 
 * 	Verwendung von virtuellen Funktionen. .
 */

#include <iostream>
#include <cstdlib>
using namespace std;

#include "../../include/tools.h"

class IReport 
{
    virtual void CreateReport() = 0;		/*	=0 ?
     * 
     * 	Das ist eine abstrakte Klasse mit einer "pure virtual function" 
     * 	=> eine Art Interface. Gekennzeichnet durch "=0".
     * 	Diese Methode muss in den Klassen definiert werden, die
     * 	von ICloneable ableiten, damit Instanzen der Klassen
     * 	erzeugt werden koennen. Sonst bleibten sie ebenfalls abstrakte 
     * 	Klassen.
     */
};

// Hier wird faktisch das Interface implementiert.
class Customer : public IReport
{
public:
    void CreateReport() { tools_log(); cout << "report created." << endl; } 
};

int main()
{
    
    //IReport r;		// Eine abstrakte Klasse kann nicht instantiiert werden.
    Customer c;
    c.CreateReport();

    return EXIT_SUCCESS;
}

